//
//  AppDelegate.m
//  KeyCode
//
//  Created by gdlocal on 2019/7/5.
//  Copyright © 2019年 gdlocal. All rights reserved.
//
#import <ApplicationServices/ApplicationServices.h>
#import <Carbon/Carbon.h>
#import "AppDelegate.h"

@interface AppDelegate ()<NSTextFieldDelegate>

@property (weak) IBOutlet NSScrollView *scrollView;

@property (weak) IBOutlet NSWindow *window;

@property (weak) IBOutlet NSTextField *textfield1;

@property (weak) IBOutlet NSTextField *textfield2;

@property (weak) IBOutlet NSTextField *textfield3;

@property (weak) IBOutlet NSTextField *textfiled4;

@property (weak) IBOutlet NSTextField *textfield5;

@end

@implementation AppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    // Insert code here to initialize your application
    
    /*
    for (int i = 0; i < 100; i++) {
        //[self simulateInputCharWithCGKeyCode:(CGKeyCode)53];
        [self simulateInputCharWithCGKeyCode:(CGKeyCode)i];
        [NSThread sleepForTimeInterval:1];
        //[self simulateInputCharWithCGKeyCode:(CGKeyCode)36];
    }
     */
    

    
    //V1.1.1 start
    
//    CGEventRef QEvent = CGEventCreateKeyboardEvent(NULL, (CGKeyCode)13, true);
//    CGEventSetFlags(QEvent, kCGEventFlagMaskCommand);
//    CGEventPost(kCGHIDEventTap, QEvent);
    
    self.textfield1.delegate = self;
    self.textfield2.delegate = self;
    self.textfield3.delegate = self;
    self.textfiled4.delegate = self;
    self.textfield5.delegate = self;
    
    //[[NSNotificationCenter defaultCenter] postNotificationName:<#(nonnull NSNotificationName)#> object:<#(nullable id)#>]
}



- (IBAction)writeBarcode:(NSButton *)sender {

    for (int i = 0; i<50; i++) {
        
        NSString *str = [NSString stringWithFormat:@"%d-C07GSREJIOGF",i+1];
        [self writeSN:str];
        
    }
}

-(void)writeSN:(NSString *)str{
    
    //[NSThread sleepForTimeInterval:2];
    NSString *tmpSN = str;
    [NSThread sleepForTimeInterval:0.005];
    [self simulateInputCharWithCGKeyCode:kVK_CapsLock];
    NSLog(@"%@",[NSDate date]);
    [NSThread sleepForTimeInterval:0.005];
    NSLog(@"%@",[NSDate date]);
    for (int i = 0; i< tmpSN.length;i++) {
        CGKeyCode keyCode = [self convert2CGKeyCodeFromChar:[tmpSN substringWithRange:NSMakeRange(i, 1)]];
        
        [self simulateInputCharWithCGKeyCode:keyCode];
    }
    [self simulateInputCharWithCGKeyCode:kVK_Return];
    
    //kVK_F1
//    CGEventRef QEvent = CGEventCreateKeyboardEvent(NULL, (CGKeyCode)13, true);
//    CGEventSetFlags(QEvent, kCGEventFlagMaskCommand);
//    CGEventPost(kCGHIDEventTap, QEvent);
    
}

-(void)simulateInputCharWithCGKeyCode:(CGKeyCode)code{//V1.1.1
    CGEventRef key = CGEventCreateKeyboardEvent(NULL,code, true);
    CGEventPost(kCGHIDEventTap, key);
    CFRelease(key);
}

-(CGKeyCode)convert2CGKeyCodeFromChar:(NSString *)str{//V1.1.1
    str = [str lowercaseString];
    if ([str isEqualToString:@"a"]) {
        return (CGKeyCode)0;
    }
    else if ([str isEqualToString:@"b"]) {
        return (CGKeyCode)11;
    }
    else if ([str isEqualToString:@"c"]) {
        return (CGKeyCode)8;
    }
    else if ([str isEqualToString:@"d"]) {
        return (CGKeyCode)2;
    }
    else if ([str isEqualToString:@"e"]) {
        return (CGKeyCode)14;
    }
    else if ([str isEqualToString:@"f"]) {
        return (CGKeyCode)3;
    }
    else if ([str isEqualToString:@"g"]) {
        return (CGKeyCode)5;
    }
    else if ([str isEqualToString:@"h"]) {
        return (CGKeyCode)4;
    }
    else if ([str isEqualToString:@"i"]) {
        return (CGKeyCode)34;
    }
    else if ([str isEqualToString:@"j"]) {
        return (CGKeyCode)38;
    }
    else if ([str isEqualToString:@"k"]) {
        return (CGKeyCode)40;
    }
    else if ([str isEqualToString:@"l"]) {
        return (CGKeyCode)37;
    }
    else if ([str isEqualToString:@"m"]) {
        return (CGKeyCode)46;
    }
    else if ([str isEqualToString:@"n"]) {
        return (CGKeyCode)45;
    }
    else if ([str isEqualToString:@"o"]) {
        return (CGKeyCode)31;
    }
    else if ([str isEqualToString:@"p"]) {
        return (CGKeyCode)35;
    }
    else if ([str isEqualToString:@"q"]) {
        return (CGKeyCode)12;
    }
    else if ([str isEqualToString:@"r"]) {
        return (CGKeyCode)15;
    }
    else if ([str isEqualToString:@"s"]) {
        return (CGKeyCode)1;
    }
    else if ([str isEqualToString:@"t"]) {
        return (CGKeyCode)17;
    }
    else if ([str isEqualToString:@"u"]) {
        return (CGKeyCode)32;
    }
    else if ([str isEqualToString:@"v"]) {
        return (CGKeyCode)9;
    }
    else if ([str isEqualToString:@"w"]) {
        return (CGKeyCode)13;
    }
    else if ([str isEqualToString:@"x"]) {
        return (CGKeyCode)7;
    }
    else if ([str isEqualToString:@"y"]) {
        return (CGKeyCode)16;
    }
    else if ([str isEqualToString:@"z"]) {
        return (CGKeyCode)6;
    }
    else if ([str isEqualToString:@"0"]) {
        return (CGKeyCode)29;
    }
    else if ([str isEqualToString:@"1"]) {
        return (CGKeyCode)18;
    }
    else if ([str isEqualToString:@"2"]) {
        return (CGKeyCode)19;
    }
    else if ([str isEqualToString:@"3"]) {
        return (CGKeyCode)20;
    }
    else if ([str isEqualToString:@"4"]) {
        return (CGKeyCode)21;
    }
    else if ([str isEqualToString:@"5"]) {
        return (CGKeyCode)23;
    }
    else if ([str isEqualToString:@"6"]) {
        return (CGKeyCode)22;
    }
    else if ([str isEqualToString:@"7"]) {
        return (CGKeyCode)26;
    }
    else if ([str isEqualToString:@"8"]) {
        return (CGKeyCode)28;
    }
    else if ([str isEqualToString:@"9"]) {
        return (CGKeyCode)25;
    }
    else if ([str isEqualToString:@"-"]) {
        return (CGKeyCode)27;
    }
    return nil;
}

///////////////////////////////////////////////////////////
- (IBAction)simulateMouse:(NSButton *)sender {
    
    
//    CGPoint pt = CGPointMake(216, 80);
//    //CGPoint pt = CGPointMake(sender.frame.origin.x, sender.frame.origin.y);
//
//    PostMouseEvent(kCGMouseButtonLeft, kCGEventLeftMouseDown, pt);
//    PostMouseEvent(kCGMouseButtonLeft, kCGEventLeftMouseUp, pt);


//    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(5 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
//        for (int i = 0; i < 10; i ++) {
//            //[self writeString:@"fasdfasdfsdfsdafsdafsfsdHello\n" withFlags:0];
//            //        if (i == 90) {
//            //            [self.textfield2 becomeFirstResponder];
//            //        }
//            [self writeString:[self getRandomStringWithNum:10 index:i] withFlags:0];
//        }
//    });
    
    for (int i = 0; i < 10; i ++) {
        //[self writeString:@"fasdfasdfsdfsdafsdafsfsdHello\n" withFlags:0];
        //        if (i == 90) {
        //            [self.textfield2 becomeFirstResponder];
        //        }
        [self writeString:[self getRandomStringWithNum:10 index:i] withFlags:0];
    }
    
}

- (NSString *)getRandomStringWithNum:(NSInteger)num index:(int)index
{
    NSString *string = [[NSString alloc]init];
    for (int i = 0; i < num; i++) {
        int number = arc4random() % 36;
        if (number < 10) {
            int figure = arc4random() % 10;
            NSString *tempString = [NSString stringWithFormat:@"%d", figure];
            string = [string stringByAppendingString:tempString];
        }else {
            int figure = (arc4random() % 26) + 97;
            char character = figure;
            NSString *tempString = [NSString stringWithFormat:@"%c", character];
            string = [string stringByAppendingString:tempString];
        }
    }
    return [NSString stringWithFormat:@"%d :ABC %@ ABC",index,string];
    //return [string stringByAppendingFormat:@"\n"];
}
void PostMouseEvent(CGMouseButton button, CGEventType type, const CGPoint point)
{
    CGEventRef theEvent = CGEventCreateMouseEvent(NULL, type, point, button);
    CGEventSetType(theEvent, type);
    CGEventPost(kCGHIDEventTap, theEvent);
    CFRelease(theEvent);
}
-(void)writeString:(NSString *)valueToSet withFlags:(int)flags
{
    NSLog(@"%@",[NSThread currentThread]);
    
    UniChar buffer;
    CGEventRef keyEventDown = CGEventCreateKeyboardEvent(NULL, 1, true);
    CGEventRef keyEventUp = CGEventCreateKeyboardEvent(NULL, 1, false);
    CGEventSetFlags(keyEventDown,0);
    CGEventSetFlags(keyEventUp,0);
    for (int i = 0; i < [valueToSet length]; i++) {
        
        [valueToSet getCharacters:&buffer range:NSMakeRange(i, 1)];
        
        CGEventKeyboardSetUnicodeString(keyEventDown, 1, &buffer);
        CGEventSetFlags(keyEventDown,flags);
        CGEventPost(kCGSessionEventTap, keyEventDown);
        
        CGEventKeyboardSetUnicodeString(keyEventUp, 1, &buffer);
        CGEventSetFlags(keyEventUp,flags);
        CGEventPost(kCGSessionEventTap, keyEventUp);
    }
    CFRelease(keyEventUp);
    CFRelease(keyEventDown);
    
    CGEventRef returnEvent = CGEventCreateKeyboardEvent(NULL, kVK_Return, true);
    CGEventPost(kCGSessionEventTap, returnEvent);
    CFRelease(returnEvent);
    
    //NSLog(@"-----------------");
//    dispatch_queue_t queue = dispatch_get_main_queue();
//    dispatch_barrier_async(queue, ^{
//        NSLog(@"*********************");
//        [self.textfield2 becomeFirstResponder];
//
//    });
    
    NSLog(@"==================");
    
}


@end
